<HTML>
<HEAD>
<link rel="stylesheet" type="text/css" href="style.css">
<meta http-equiv=refresh content='60;url=default.asp'>
<TITLE>Live Monitoring</TITLE>
</HEAD>
<BODY>
<%
'SET STATIC SERVERS AND NAME
arrComputers = Array()
arrComputerNames = Array()
'GENERAL SETTINGS
StrStopColor="Red"
AlertsPath=Server.MapPath("ALERTS\")
StatusPath=Server.MapPath("STATUS\")
AudioPath=Server.MapPath("AUDIO\")
'UNICODE SETTINGS
Dim arrBOM(14)
arrBOM(0) = Chr(&HEF) & Chr(&HBB) & Chr(&HBF)
arrBOM(1) = Chr(&HFE) & Chr(&HFF)
arrBOM(2) = Chr(&HFF) & Chr(&HFE)
arrBOM(3) = Chr(&H00) & Chr(&H00) & Chr(&HFE) & Chr(&HFF)
arrBOM(4) = Chr(&HFF) & Chr(&HFE) & Chr(&H00) & Chr(&H00)
arrBOM(5) = Chr(&H2B) & Chr(&H2F) & Chr(&H76) & Chr(&H38)
arrBOM(6) = Chr(&H2B) & Chr(&H2F) & Chr(&H76) & Chr(&H39)
arrBOM(7) = Chr(&H2B) & Chr(&H2F) & Chr(&H76) & Chr(&H2B)
arrBOM(8) = Chr(&H2B) & Chr(&H2F) & Chr(&H76) & Chr(&H2F)
arrBOM(9) = Chr(&H2B) & Chr(&H2F) & Chr(&H76) & Chr(&H38) & Chr(&H2D)
arrBOM(10) = Chr(&HF7) & Chr(&H64) & Chr(&H4C)
arrBOM(11) = Chr(&HDD) & Chr(&H73) & Chr(&H66) & Chr(&H73)
arrBOM(12) = Chr(&H0E) & Chr(&HFE) & Chr(&HFF)
arrBOM(13) = Chr(&HFB) & Chr(&HEE) & Chr(&H28)
arrBOM(14) = Chr(&H84) & Chr(&H31) & Chr(&H95) & Chr(&H33)


'FUNCTIONS

Function SoundAlert()

	Set fso = CreateObject("Scripting.FileSystemObject")
	Set folder = fso.GetFolder(AudioPath)
	Set files = folder.Files
	wavFileCount = 0
	
	For Each file in files
		name = lcase(file)
		if right(name, 3) = "wav" then
			wavFileCount = wavFileCount + 1
			ReDim Preserve wavFiles(wavFileCount)
			wavFiles(wavFileCount - 1) = name
		end if
	Next
	
	If wavFileCount < 1 then
		Response.Write "No alert wave files found!"
	End If

	Randomize
	randomIndex = Int(rnd * wavFileCount)
	randomWavFile = wavFiles(randomIndex)
	Response.Write "<audio autoplay><source src='AUDIO/" & fso.GetFileName(randomWavFile) & "' type='audio/wav'><bgsound src='AUDIO/"& fso.GetFileName(randomWavFile) &"' type='audio/wav' loop=1>Audio not supported</audio>"
	set fso = nothing
	set folder = nothing
	set files = nothing
	
End function

Function GetFilenameWithoutExtension(ByVal FileName)
  Dim Result, i
  Result = FileName
  i = InStrRev(FileName, ".")
  If ( i > 0 ) Then
    Result = Mid(FileName, 1, i - 1)
  End If
  GetFilenameWithoutExtension = Result
End Function

'START

'IDENTIFY NEW MACHINES
Set newFSO = CreateObject("Scripting.FileSystemObject")
Set newfolder = newFSO.GetFolder(StatusPath)

For each newfile In newfolder.Files
	serverfound = False
	machinename = GetFilenameWithoutExtension(newfile.name)
	For a = 0 to UBound(arrComputers)
		If arrComputers(a) = machinename Then serverfound = True
	Next
    If serverfound = False then
		ReDim Preserve arrComputers(UBound(arrComputers) + 1)
		arrComputers(UBound(arrComputers)) = machinename
		ReDim Preserve arrComputerNames(UBound(arrComputerNames) + 1)
		arrComputerNames(UBound(arrComputerNames)) = machinename
	End If
Next

i=0
alerts=0
For each ThisComputer in arrComputers
	AlertString = ""
	on error resume next
	'CHECK MONITORING STATUS
		StatusTime = ""
		Online = False
		Set oFSOstatus = CreateObject("Scripting.FileSystemObject")
			strFilestatus = StatusPath & "\" & ThisComputer & ".txt"
		If oFSO.FileExists(strFilestatus) then 
				set filstatus = oFSOstatus.OpenTextFile(strFilestatus)
				StatusTime = filstatus.ReadAll
				set filstatus = Nothing
		End If
		If DateDiff("n",StatusTime,Now)>=2 then
				StatusTime = "<font color='red'>" & StatusTime & "</font>"
				Online = False
		Else
				StatusTime = "<font color='green'>" & StatusTime & "</font>"
				Online = True
		End If
		set oFSOstatus = nothing
		
	'FIND FILE ALERTS
		Set oFSO = CreateObject("Scripting.FileSystemObject")
		Set ofolder = oFSO.GetFolder(AlertsPath)
		For each ofile In ofolder.Files    
			If instr(ofile.name,ThisComputer) = 1 Then 
				set fil = oFSO.OpenTextFile(ofile)
				tmpsig = Left(fil.ReadAll,5)
				For Each strBOM In arrBOM
					If Left(tmpsig, Len(strBOM)) = strBOM Then
						bUnicode = True
						Exit For
					Else 
						bUnicode = False
					End If
				Next
				set fil = Nothing
				If bUnicode then 
					set fil = oFSO.OpenTextFile(ofile,1,false,-1)
					Else
					set fil = oFSO.OpenTextFile(ofile,1,false,0)
				End If
				If AlertString = "" Then AlertString = AlertString & "<table border=1 cellspacing=0 cellpadding=0 width=760 style='border-collapse:collapse;width:570.0pt;padding-left:10px;'>"
				AlertString = AlertString & fil.ReadAll
				Set fil = Nothing
			End If
		Next
		Set oFSO = Nothing

	'GENERATE SERVER SUMMARY
	Response.Write "<table class='servertable'><tr class='servertr'><td class='servertd'>"
	If AlertString <> "" then 
		Response.Write "<img src='Alert.png' align='top'/> "
	ElseIf Online = True then
		Response.Write "<img src='On.png' align='top' height='15'/> "
	ElseIf Online = False then
		Response.Write "<img src='Off.png' align='top' height='15'/> "
	End IF
	Response.Write "<STRONG>" & arrComputerNames(i) & "</STRONG> (" & ThisComputer & ")"
	Response.Write "</td><td width='25%' class='servertd'>"
	Response.Write StatusTime
	Response.Write "</td><td width='25%' class='servertd'>"
	Response.Write " <a href='detail.asp?COMPUTERNAME=" & ThisComputer & "'><img src='Detail.png' align='top'/></a> "
	Response.Write " <a href='clearalerts.asp?COMPUTERNAME=" & ThisComputer & "'><img src='ClearAlerts.png' align='top'/></a>"
	Response.Write "</td></tr></table><HR>"
		
	'GENERATE ALERT SUMMARY
	If AlertString <> "" then	
		Response.Write AlertString & "</table>"
		Response.Write "<HR>"
		alerts = alerts + 1
	End If
		i = i + 1
Next
If alerts > 0 then 
	SoundAlert()
End If
Response.End
%>
</BODY>
</HTML>