<%
'SETTINGS
AlertsPath=Server.MapPath("ALERTS\")

'REQUESTS
ThisFrom = Trim(Request.Form("FROM"))
If Trim(Time)="" then ThisFrom=Trim(Request("FROM"))
ThisTo = Trim(Request.Form("TO"))
If Trim(Time)="" then ThisTo=Trim(Request("TO"))
ThisCc = Trim(Request.Form("CC"))
If Trim(Time)="" then ThisCc=Trim(Request("CC"))
ThisBcc = Trim(Request.Form("BCC"))
If Trim(Time)="" then ThisBcc=Trim(Request("BCC"))
ThisSubject = Trim(Request.Form("SUBJECT"))
If Trim(Time)="" then ThisSubject=Trim(Request("SUBJECT"))
ThisHtml = Trim(Request.Form("HTMLBODY"))
If Trim(Time)="" then ThisHtml=Trim(Request("HTMLBODY"))
ThisText = Trim(Request.Form("TEXTBODY"))
If Trim(Time)="" then ThisText=Trim(Request("TEXTBODY"))
ThisServer = Trim(Request.Form("SERVER"))
If Trim(Time)="" then ThisServer=Trim(Request("SERVER"))
ThisPort = Trim(Request.Form("PORT"))
If Trim(Time)="" then ThisPort=Trim(Request("PORT"))
If ThisPort="" Then ThisPort="25"
ThisUser = Trim(Request.Form("USER"))
If Trim(Time)="" then ThisUser=Trim(Request("USER"))
ThisPassword = Trim(Request.Form("PASSWORD"))
If Trim(Time)="" then ThisPassword=Trim(Request("PASSWORD"))
ThisSSL = Trim(Request.Form("SSL"))
If Trim(Time)="" then ThisSSL=Trim(Request("SSL"))
If ThisSSL = "" Then ThisSSL = "False"

'FUNCTIONS
Function strnullcheck(varString)
	If Isnull(varString) Then
		strnullcheck = ""
	Else
		strnullcheck = varString
	End If 	
End Function

Function SendEmail()
Const cdoSendUsingPickup = 1 'Send message using the local SMTP service pickup directory. 
Const cdoSendUsingPort = 2 'Send the message using the network (SMTP over the network). 

Const cdoAnonymous = 0 'Do not authenticate
Const cdoBasic = 1 'basic (clear-text) authentication
Const cdoNTLM = 2 'NTLM

Set objMessage = CreateObject("CDO.Message") 
objMessage.Subject = ThisSubject
objMessage.From = ThisFrom
objMessage.To = ThisTo
objMessage.Cc = ThisCc
objMessage.Bcc = ThisBcc
objMessage.HTMLBody = ThisHtml
objMessage.TextBody = ThisText

'==This section provides the configuration information for the remote SMTP server.
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusing") = 2 
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserver") = strnullcheck(ThisServer)
If ThisUser <> "" and ThisPassword <> "" Then
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
Else
	objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 0
End If
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendusername") = strnullcheck(ThisUser)
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/sendpassword") = strnullcheck(ThisPassword)
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpserverport") = strnullcheck(ThisPort)
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpusessl") = strnullcheck(ThisSSL)
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 20000
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/urlproxyserver") = ""
objMessage.Configuration.Fields.Item ("http://schemas.microsoft.com/cdo/configuration/urlproxybypass") = ""
objMessage.Configuration.Fields.Update
'==End remote SMTP server configuration section==
objMessage.Send
Set objMessage = Nothing
Response.Write "<STRONG>Email Sent!</STRONG><br/>"
End Function

'START
If ThisServer <> "" and ThisFrom <> "" and ThisTo <> "" Then
	Response.Write "<HTML><HEAD><link rel='stylesheet' type='text/css' href='style.css'><meta http-equiv=refresh content='30;url=default.asp'><TITLE>Monitoring Emails</TITLE></HEAD><BODY>"
	Response.Write "From: " & ThisFrom & "<br/>"
	Response.Write "To: " & ThisTo & "<br/>"
	Response.Write "Cc: " & ThisCc & "<br/>"
	Response.Write "Bcc: " & ThisBcc & "<br/>"
	Response.Write "<STRONG>" & ThisSubject & "</STRONG><br/>"
	Response.Write "<P>Html Body: <em>" & ThisHtml & "</em></P>"
	Response.Write "<P>Text Body: <em>" & ThisText & "</em></P>"
	Response.Write "Server: " & ThisServer & "<br/>"
	Response.Write "Port: " & ThisPort & "<br/>"
	Response.Write "User: " & ThisUser & "<br/>"
	Response.Write "Password: "
	If ThisPassword <> "" Then Response.Write "*******"
	Response.Write "<br/>"
	Response.Write "Use SSL: " & ThisSSL & "<br/>"
	
	SendEmail()
	
	Response.Write "</BODY></HTML>"
	Response.End
End If

%>
<HTML>
<HEAD>
<link rel="stylesheet" type="text/css" href="style.css">
<meta http-equiv=refresh content="120;url=default.asp">
<TITLE>Monitoring Emails</TITLE>
</HEAD>
<BODY>
Insufficient information specified for email.
<br/><br/>
<STRONG>Test Email Submission</STRONG><br/>
<form action="emails.asp" method="post">
<table>
<tr class='servertr'><td class='servertd'>From: </td><td class='servertd'><input type="text" name="FROM"></td></tr>
<tr class='servertr'><td class='servertd'>To: </td><td class='servertd'><input type="text" name="TO"></td></tr>
<tr class='servertr'><td class='servertd'>Cc: </td><td class='servertd'><input type="text" name="CC"></td></tr>
<tr class='servertr'><td class='servertd'>Bcc: </td><td class='servertd'><input type="text" name="BCC"></td></tr>
<tr class='servertr'><td class='servertd'>Subject: </td><td class='servertd'><input type="text" name="SUBJECT"></td></tr>
<tr class='servertr'><td class='servertd'>HTML Content: </td><td class='servertd'><textarea type="text" name="HTMLBODY"></textarea></td></tr>
<tr class='servertr'><td class='servertd'>Text Content: </td><td class='servertd'><textarea type="text" name="TEXTBODY"></textarea></td></tr>
<tr class='servertr'><td class='servertd'>Server: </td><td class='servertd'><input type="text" name="SERVER"></td></tr>
<tr class='servertr'><td class='servertd'>Port: </td><td class='servertd'><input type="text" name="PORT" value="25"></td></tr>
<tr class='servertr'><td class='servertd'>User: </td><td class='servertd'><input type="text" name="USER"></td></tr>
<tr class='servertr'><td class='servertd'>Password: </td><td class='servertd'><input type="password" name="PASSWORD"></td></tr>
<tr class='servertr'><td class='servertd'>Use SSL: </td><td class='servertd'><input type="text" name="SSL" value="False"></td></tr>
<tr class='servertr'><td class='servertd'></td><td class='servertd'><input type="submit" value="Submit"></td></tr>
</table>
</form>
</BODY>
</HTML>